<template>
  <div class="app-container">
    <!-- 查询和其他操作 -->
    <div class="filter-container" style="margin: 10px 0 10px 0;">
      <el-form :inline="true" label-width="68px" style="margin-bottom: 8px;">
        <el-col :span="18">
          <el-form-item label="项目名称 ">
            {{projectName}}
          </el-form-item>
        </el-col>
        <el-col :span="6">
          <el-button class="filter-item" type="primary" @click="handleAdd" icon="el-icon-edit">新增用戶类型</el-button>
        </el-col>
      </el-form>
    </div>

    <el-table :data="tableData" style="width:100%" class="show_table" >

      <el-table-column label="ID" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.uid }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用戶等级ID" width="100" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.levelId }}</span>
        </template>
      </el-table-column>
      <el-table-column label="用戶等级名称" width="300" :show-overflow-tooltip="true" align="left">
        <template slot-scope="scope">
          <span>{{ scope.row.levelName }}</span>
        </template>
      </el-table-column>
      <el-table-column label="每日可看话数或集数" width="100" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span>{{ scope.row.enableEpisode }}</span>
        </template>
      </el-table-column>
      <el-table-column label="状态" width="80" :show-overflow-tooltip="true" align="center">
        <template slot-scope="scope">
          <span v-if="scope.row.status == 0">停用</span>
          <span v-if="scope.row.status == 1">启用</span>
        </template>
      </el-table-column>
      <el-table-column label="建立时间" width="180" align="center" prop="createdAt" sortable="custom" :sort-by="['createdAt']">
        <template slot-scope="scope">
          <span>{{ scope.row.createTime }}</span>
        </template>
      </el-table-column>

      <el-table-column label="操作" min-width="80" fixed="right" align="center">
        <template slot-scope="scope">
        <el-button @click="handleEdit(scope.row)"  type="primary" size="small">编辑</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!--分页-->
    <div class="block">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page.sync="currentPage"
        :page-sizes="[40, 80, 120, 200]"
        :page-size="pageSize"
        layout="total, prev, pager, next, jumper, sizes"
        :total="total"
      ></el-pagination>
    </div>
    <!-- 添加或修改对话框 -->
    <el-dialog :title="title" :visible.sync="dialogFormVisible" width="50%" :before-close="handleClose" center>
      <el-form :model="form" :rules="rules" ref="form" label-width="auto">
        <el-form-item label="ID" :label-width="formLabelWidth" v-if="form.uid">
          <span>{{form.uid}}</span>
        </el-form-item>
        <el-form-item label="会员等级名称" :label-width="formLabelWidth">
          <el-select v-model="levelValue"
                     @input="levelContentChange"
                     placeholder="请选择" filterable>
            <el-option
              v-for="item in this.levelData"
              :key="item.levelKey"
              :label="item.levelName"
              :value="item.levelKey"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="每日可看话数或集数" :label-width="formLabelWidth" prop="enableEpisode">
          <el-input v-model="form.enableEpisode" oninput ="value=value.replace(/[^\d]/g,'')"  style="width:80%"></el-input>
        </el-form-item>
        <el-form-item label="" :label-width="formLabelWidth" prop="projectUid">
          <el-input v-model="form.projectUid" style="width:80%" hidden></el-input>
        </el-form-item>
        <el-form-item label="狀態" :label-width="formLabelWidth" prop="status">
          <el-switch v-model="form.status"
                     active-color="#13ce66"
                     inactive-color="#ff4949"
                     active-text="启用"
                     inactive-text="不启用"
                     :active-value="1"
                     :inactive-value="0" >
          </el-switch>
        </el-form-item>
        <el-form-item label="建立時間" :label-width="formLabelWidth" v-if="form.createTime">
          <span>{{form.createTime}}</span>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="handleClose">取 消</el-button>
        <el-button type="primary" @click="submitForm">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  getBooksUserCostList,
  addBooksUserCost,
  editBooksUserCost,
  getLevelList,
} from "@/api/booksUserCost";

export default {
  data() {
    return {

      queryParams:{//查询参数
        projectUid: "",
      },
      projectName:"",
      projectUid: "",
      tableData: [],
      levelData: [
        {
          levelName:'请选择',
          levelKey:null}
      ],
      levelValue: null, //保存选中id(编辑时)
      form: {
        uid: null,
        levelUid: null,
        enableEpisode: null,
        status: null,
        projectUid: null,
        createTime:null
      },
      rules: {
        levelValue: [
          {required: true, message: '请选择会员等级名称', trigger: 'blur'},
        ],
        enableEpisode: [
          {required: true, message: '每日可看话数或集数需有值', trigger: 'blur'},
        ]
      },
      dialogFormVisible: false,
      isEditForm: false,
      isAddForm: false,
      currentPage: 1,
      pageSize: 40,
      total: 0, //总数量
      orderByDescColumn: "", // 降序字段
      orderByAscColumn: "", // 升序字段
      dialogVisible: false,
    };
  },
  created() {
    this.booksUserCostList();
    this.levelList();
  },
  methods: {
    // 内容改变，触发监听
    levelContentChange: function() {
      this.form.levelUid = this.levelValue;
    },
    booksUserCostList: function() {
      console.log(this.$route.query.projectUid);
      this.projectUid = this.$route.query.projectUid;
      this.projectName = this.$route.query.projectName;
      this.queryParams.projectUid=this.projectUid;
      this.queryParams.currentPage = this.currentPage;
      this.queryParams.pageSize = this.pageSize;
      this.queryParams.orderByDescColumn = this.orderByDescColumn
      this.queryParams.orderByAscColumn = this.orderByAscColumn
      getBooksUserCostList(this.queryParams).then(response => {
        this.tableData = response.data.records;
        this.currentPage = response.data.current;
        this.pageSize = response.data.size;
        this.total = response.data.total;
      });
    },
    levelList: function() {
      this.queryParams.projectUid=this.projectUid;
      getLevelList(this.queryParams).then(response => {
        this.levelData.push(...response.data);
      });
    },
    handleAdd: function() {
      this.title = "新增用戶类型"
      this.dialogFormVisible = true;
      this.form = this.getFormObject();
      this.isEditForm = false;
      this.isAddForm = true;
      this.levelValue = null;
    },
    handleEdit: function(row) {
      this.title = "编辑用戶类型";
      this.dialogFormVisible = true;
      this.isEditForm = true;
      this.isAddForm = false;
      this.form = row;
      this.levelValue = this.form.levelUid;
    },
    submitForm: function() {
      this.$refs.form.validate((valid) => {
        if(!valid) {
          console.log("校验出错")
        } else {
          if (this.isEditForm) {
            editBooksUserCost(this.form).then(response => {
              this.$commonUtil.message.success(response.message)
              this.dialogFormVisible = false;
              this.booksUserCostList();
            });
          } else {
            addBooksUserCost(this.form).then(response => {
              if (response.code == this.$ECode.SUCCESS) {
                this.$commonUtil.message.success(response.message)
              } else {
                this.$commonUtil.message.error(response.message)
              }
              this.dialogFormVisible = false;
              this.booksUserCostList();
            });
          }
        }
      })
    },
    handleFind: function() {
      this.currentPage = 1
      this.booksUserCostList();
    },
    getFormObject: function() {
      var formObject = {
        uid: null,
        levelUid: null,
        enableEpisode:null,
        status: 1,
        projectUid: this.projectUid,
      };
      return formObject;
    },
    handleClose(){
      this.dialogFormVisible = false;
      this.$refs.form.clearValidate();
      this.booksUserCostList();
    },

    /**
     * 翻页事件
     */
    handleSizeChange(val) {
      this.pageSize = val;
      this.booksUserCostList();
    },
    handleCurrentChange: function(val) {
      this.currentPage = val;
      this.booksUserCostList();
    },

  }
};
</script>
<style scoped>
  .el-form-item {
    margin-bottom: 16px;
  }
</style>
